/*
 * libclose.c - loader for library
 *
 * Copyright (C) 2018 Thorsten Otto
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
#include "slb/iconv.h"
#include <stdio.h>
#include <mint/mintbind.h>
#include <time.h>
#include "libstrct.h"
#include "slbload.h"

struct _iconvslb_funcs iconvslb_funcs;


static long _CDECL slb_unloaded(SLB_HANDLE slb, long fn, short nwords, ...)
{
	(void)slb;
	(void)fn;
	(void)nwords;
	(void) Cconws(SHAREDLIB " was already unloaded\r\n");
	Pterm(1);
	return -32;
}


void slb_iconv_close(void)
{
	SLB *iconvlib = slb_iconv_get();

	if (!iconvlib)
		return;
	if (iconvlib->handle)
	{
		slb_unload(iconvlib->handle);
		iconvlib->handle = 0;
	}
	iconvlib->exec = slb_unloaded;
}
